0.9.9 API documenation: GLM_GTC_matrix_transform

| 0.9.9 API documenation

- Main Page
- Modules
- Files

Functions
GLM_GTC_matrix_transform
GTC Extensions (Stable)

Defines functions that generate common transformation matrices. More...

## Functions
template<typename T >
GLM_FUNC_DECL tmat4x4< T, defaultp > | frustum (T left, T right, T bottom, T top, T near, T far)
| Creates a frustum matrix with default handedness. More...
template<typename T >
GLM_FUNC_DECL tmat4x4< T, defaultp > | frustumLH (T left, T right, T bottom, T top, T near, T far)
| Creates a left handed frustum matrix. More...
template<typename T >
GLM_FUNC_DECL tmat4x4< T, defaultp > | frustumRH (T left, T right, T bottom, T top, T near, T far)
| Creates a right handed frustum matrix. More...
template<typename T >
GLM_FUNC_DECL tmat4x4< T, defaultp > | infinitePerspective (T fovy, T aspect, T near)
| Creates a matrix for a symmetric perspective-view frustum with far plane at infinite with default handedness. More...
template<typename T >
GLM_FUNC_DECL tmat4x4< T, defaultp > | infinitePerspectiveLH (T fovy, T aspect, T near)
| Creates a matrix for a left handed, symmetric perspective-view frustum with far plane at infinite. More...
template<typename T >
GLM_FUNC_DECL tmat4x4< T, defaultp > | infinitePerspectiveRH (T fovy, T aspect, T near)
| Creates a matrix for a right handed, symmetric perspective-view frustum with far plane at infinite. More...
template<typename T , precision P>
GLM_FUNC_DECL tmat4x4< T, P > | lookAt (tvec3< T, P > const &eye, tvec3< T, P > const &center, tvec3< T, P > const &up)
| Build a look at view matrix based on the default handedness. More...
template<typename T , precision P>
GLM_FUNC_DECL tmat4x4< T, P > | lookAtLH (tvec3< T, P > const &eye, tvec3< T, P > const &center, tvec3< T, P > const &up)
| Build a left handed look at view matrix. More...
template<typename T , precision P>
GLM_FUNC_DECL tmat4x4< T, P > | lookAtRH (tvec3< T, P > const &eye, tvec3< T, P > const &center, tvec3< T, P > const &up)
| Build a right handed look at view matrix. More...
template<typename T >
GLM_FUNC_DECL tmat4x4< T, defaultp > | ortho (T left, T right, T bottom, T top, T zNear, T zFar)
| Creates a matrix for an orthographic parallel viewing volume, using the default handedness. More...
template<typename T >
GLM_FUNC_DECL tmat4x4< T, defaultp > | ortho (T left, T right, T bottom, T top)
| Creates a matrix for projecting two-dimensional coordinates onto the screen. More...
template<typename T >
GLM_FUNC_DECL tmat4x4< T, defaultp > | orthoLH (T left, T right, T bottom, T top, T zNear, T zFar)
| Creates a matrix for an orthographic parallel viewing volume, using left-handedness. More...
template<typename T >
GLM_FUNC_DECL tmat4x4< T, defaultp > | orthoRH (T left, T right, T bottom, T top, T zNear, T zFar)
| Creates a matrix for an orthographic parallel viewing volume, using right-handedness. More...
template<typename T >
GLM_FUNC_DECL tmat4x4< T, defaultp > | perspective (T fovy, T aspect, T near, T far)
| Creates a matrix for a symetric perspective-view frustum based on the default handedness. More...
template<typename T >
GLM_FUNC_DECL tmat4x4< T, defaultp > | perspectiveFov (T fov, T width, T height, T near, T far)
| Builds a perspective projection matrix based on a field of view and the default handedness. More...
template<typename T >
GLM_FUNC_DECL tmat4x4< T, defaultp > | perspectiveFovLH (T fov, T width, T height, T near, T far)
| Builds a left handed perspective projection matrix based on a field of view. More...
template<typename T >
GLM_FUNC_DECL tmat4x4< T, defaultp > | perspectiveFovRH (T fov, T width, T height, T near, T far)
| Builds a right handed perspective projection matrix based on a field of view. More...
template<typename T >
GLM_FUNC_DECL tmat4x4< T, defaultp > | perspectiveLH (T fovy, T aspect, T near, T far)
| Creates a matrix for a left handed, symetric perspective-view frustum. More...
template<typename T >
GLM_FUNC_DECL tmat4x4< T, defaultp > | perspectiveRH (T fovy, T aspect, T near, T far)
| Creates a matrix for a right handed, symetric perspective-view frustum. More...
template<typename T , precision P, typename U >
GLM_FUNC_DECL tmat4x4< T, P > | pickMatrix (tvec2< T, P > const &center, tvec2< T, P > const &delta, tvec4< U, P > const &viewport)
| Define a picking region. More...
template<typename T , typename U , precision P>
GLM_FUNC_DECL tvec3< T, P > | project (tvec3< T, P > const &obj, tmat4x4< T, P > const &model, tmat4x4< T, P > const &proj, tvec4< U, P > const &viewport)
| Map the specified object coordinates (obj.x, obj.y, obj.z) into window coordinates. More...
template<typename T , precision P>
GLM_FUNC_DECL tmat4x4< T, P > | rotate (tmat4x4< T, P > const &m, T angle, tvec3< T, P > const &axis)
| Builds a rotation 4 * 4 matrix created from an axis vector and an angle. More...
template<typename T , precision P>
GLM_FUNC_DECL tmat4x4< T, P > | scale (tmat4x4< T, P > const &m, tvec3< T, P > const &v)
| Builds a scale 4 * 4 matrix created from 3 scalars. More...
template<typename T , precision P>
GLM_FUNC_DECL tmat4x4< T, P > | translate (tmat4x4< T, P > const &m, tvec3< T, P > const &v)
| Builds a translation 4 * 4 matrix created from a vector of 3 components. More...
template<typename T >
GLM_FUNC_DECL tmat4x4< T, defaultp > | tweakedInfinitePerspective (T fovy, T aspect, T near)
| Creates a matrix for a symmetric perspective-view frustum with far plane at infinite for graphics hardware that doesn't support depth clamping. More...
template<typename T >
GLM_FUNC_DECL tmat4x4< T, defaultp > | tweakedInfinitePerspective (T fovy, T aspect, T near, T ep)
| Creates a matrix for a symmetric perspective-view frustum with far plane at infinite for graphics hardware that doesn't support depth clamping. More...
template<typename T , typename U , precision P>
GLM_FUNC_DECL tvec3< T, P > | unProject (tvec3< T, P > const &win, tmat4x4< T, P > const &model, tmat4x4< T, P > const &proj, tvec4< U, P > const &viewport)
| Map the specified window coordinates (win.x, win.y, win.z) into object coordinates. More...

## Detailed Description

Defines functions that generate common transformation matrices.

The matrices generated by this extension use standard OpenGL fixed-function conventions. For example, the lookAt function generates a transform from world space into the specific eye space that the projective matrix functions (perspective, ortho, etc) are designed to expect. The OpenGL compatibility specifications defines the particular layout of this eye space.

<glm/gtc/matrix_transform.hpp> need to be included to use these functionalities.

## Function Documentation

GLM_FUNC_DECL tmat4x4<T, defaultp> glm::frustum | ( | T | left,
|  | T | right,
|  | T | bottom,
|  | T | top,
|  | T | near,
|  | T | far
| ) |  |

Creates a frustum matrix with default handedness.

Parameters

  left |
  right |
  bottom |
  top |
  near |
  far |

Template Parameters

  T | Value type used to build the matrix. Currently supported: half (not recommanded), float or double.

See also
  GLM_GTC_matrix_transform

GLM_FUNC_DECL tmat4x4<T, defaultp> glm::frustumLH | ( | T | left,
|  | T | right,
|  | T | bottom,
|  | T | top,
|  | T | near,
|  | T | far
| ) |  |

Creates a left handed frustum matrix.

Parameters

  left |
  right |
  bottom |
  top |
  near |
  far |

Template Parameters

  T | Value type used to build the matrix. Currently supported: half (not recommanded), float or double.

See also
  GLM_GTC_matrix_transform

GLM_FUNC_DECL tmat4x4<T, defaultp> glm::frustumRH | ( | T | left,
|  | T | right,
|  | T | bottom,
|  | T | top,
|  | T | near,
|  | T | far
| ) |  |

Creates a right handed frustum matrix.

Parameters

  left |
  right |
  bottom |
  top |
  near |
  far |

Template Parameters

  T | Value type used to build the matrix. Currently supported: half (not recommanded), float or double.

See also
  GLM_GTC_matrix_transform

GLM_FUNC_DECL tmat4x4<T, defaultp> glm::infinitePerspective | ( | T | fovy,
|  | T | aspect,
|  | T | near
| ) |  |

Creates a matrix for a symmetric perspective-view frustum with far plane at infinite with default handedness.

Parameters

  fovy | Specifies the field of view angle, in degrees, in the y direction. Expressed in radians.
  aspect | Specifies the aspect ratio that determines the field of view in the x direction. The aspect ratio is the ratio of x (width) to y (height).
  near | Specifies the distance from the viewer to the near clipping plane (always positive).

Template Parameters

  T | Value type used to build the matrix. Currently supported: half (not recommanded), float or double.

See also
  GLM_GTC_matrix_transform

GLM_FUNC_DECL tmat4x4<T, defaultp> glm::infinitePerspectiveLH | ( | T | fovy,
|  | T | aspect,
|  | T | near
| ) |  |

Creates a matrix for a left handed, symmetric perspective-view frustum with far plane at infinite.

Parameters

  fovy | Specifies the field of view angle, in degrees, in the y direction. Expressed in radians.
  aspect | Specifies the aspect ratio that determines the field of view in the x direction. The aspect ratio is the ratio of x (width) to y (height).
  near | Specifies the distance from the viewer to the near clipping plane (always positive).

Template Parameters

  T | Value type used to build the matrix. Currently supported: half (not recommanded), float or double.

See also
  GLM_GTC_matrix_transform

GLM_FUNC_DECL tmat4x4<T, defaultp> glm::infinitePerspectiveRH | ( | T | fovy,
|  | T | aspect,
|  | T | near
| ) |  |

Creates a matrix for a right handed, symmetric perspective-view frustum with far plane at infinite.

Parameters

  fovy | Specifies the field of view angle, in degrees, in the y direction. Expressed in radians.
  aspect | Specifies the aspect ratio that determines the field of view in the x direction. The aspect ratio is the ratio of x (width) to y (height).
  near | Specifies the distance from the viewer to the near clipping plane (always positive).

Template Parameters

  T | Value type used to build the matrix. Currently supported: half (not recommanded), float or double.

See also
  GLM_GTC_matrix_transform

GLM_FUNC_DECL tmat4x4<T, P> glm::lookAt | ( | tvec3< T, P > const & | eye,
|  | tvec3< T, P > const & | center,
|  | tvec3< T, P > const & | up
| ) |  |

Build a look at view matrix based on the default handedness.

Parameters

  eye | Position of the camera
  center | Position where the camera is looking at
  up | Normalized up vector, how the camera is oriented. Typically (0, 0, 1)

See also
  GLM_GTC_matrix_transform
  - frustum(T const & left, T const & right, T const & bottom, T const & top, T const & nearVal, T const & farVal) frustum(T const & left, T const & right, T const & bottom, T const & top, T const & nearVal, T const & farVal)

GLM_FUNC_DECL tmat4x4<T, P> glm::lookAtLH | ( | tvec3< T, P > const & | eye,
|  | tvec3< T, P > const & | center,
|  | tvec3< T, P > const & | up
| ) |  |

Build a left handed look at view matrix.

Parameters

  eye | Position of the camera
  center | Position where the camera is looking at
  up | Normalized up vector, how the camera is oriented. Typically (0, 0, 1)

See also
  GLM_GTC_matrix_transform
  - frustum(T const & left, T const & right, T const & bottom, T const & top, T const & nearVal, T const & farVal) frustum(T const & left, T const & right, T const & bottom, T const & top, T const & nearVal, T const & farVal)

GLM_FUNC_DECL tmat4x4<T, P> glm::lookAtRH | ( | tvec3< T, P > const & | eye,
|  | tvec3< T, P > const & | center,
|  | tvec3< T, P > const & | up
| ) |  |

Build a right handed look at view matrix.

Parameters

  eye | Position of the camera
  center | Position where the camera is looking at
  up | Normalized up vector, how the camera is oriented. Typically (0, 0, 1)

See also
  GLM_GTC_matrix_transform
  - frustum(T const & left, T const & right, T const & bottom, T const & top, T const & nearVal, T const & farVal) frustum(T const & left, T const & right, T const & bottom, T const & top, T const & nearVal, T const & farVal)

GLM_FUNC_DECL tmat4x4<T, defaultp> glm::ortho | ( | T | left,
|  | T | right,
|  | T | bottom,
|  | T | top,
|  | T | zNear,
|  | T | zFar
| ) |  |

Creates a matrix for an orthographic parallel viewing volume, using the default handedness.

Parameters

  left |
  right |
  bottom |
  top |
  zNear |
  zFar |

Template Parameters

  T | Value type used to build the matrix. Currently supported: half (not recommanded), float or double.

See also
  GLM_GTC_matrix_transform
  - glm::ortho(T const & left, T const & right, T const & bottom, T const & top)

GLM_FUNC_DECL tmat4x4<T, defaultp> glm::ortho | ( | T | left,
|  | T | right,
|  | T | bottom,
|  | T | top
| ) |  |

Creates a matrix for projecting two-dimensional coordinates onto the screen.

Parameters

  left |
  right |
  bottom |
  top |

Template Parameters

  T | Value type used to build the matrix. Currently supported: half (not recommanded), float or double.

See also
  GLM_GTC_matrix_transform
  - glm::ortho(T const & left, T const & right, T const & bottom, T const & top, T const & zNear, T const & zFar)

GLM_FUNC_DECL tmat4x4<T, defaultp> glm::orthoLH | ( | T | left,
|  | T | right,
|  | T | bottom,
|  | T | top,
|  | T | zNear,
|  | T | zFar
| ) |  |

Creates a matrix for an orthographic parallel viewing volume, using left-handedness.

Parameters

  left |
  right |
  bottom |
  top |
  zNear |
  zFar |

Template Parameters

  T | Value type used to build the matrix. Currently supported: half (not recommanded), float or double.

See also
  GLM_GTC_matrix_transform
  - glm::ortho(T const & left, T const & right, T const & bottom, T const & top)

GLM_FUNC_DECL tmat4x4<T, defaultp> glm::orthoRH | ( | T | left,
|  | T | right,
|  | T | bottom,
|  | T | top,
|  | T | zNear,
|  | T | zFar
| ) |  |

Creates a matrix for an orthographic parallel viewing volume, using right-handedness.

Parameters

  left |
  right |
  bottom |
  top |
  zNear |
  zFar |

Template Parameters

  T | Value type used to build the matrix. Currently supported: half (not recommanded), float or double.

See also
  GLM_GTC_matrix_transform
  - glm::ortho(T const & left, T const & right, T const & bottom, T const & top)

GLM_FUNC_DECL tmat4x4<T, defaultp> glm::perspective | ( | T | fovy,
|  | T | aspect,
|  | T | near,
|  | T | far
| ) |  |

Creates a matrix for a symetric perspective-view frustum based on the default handedness.

Parameters

  fovy | Specifies the field of view angle in the y direction. Expressed in radians.
  aspect | Specifies the aspect ratio that determines the field of view in the x direction. The aspect ratio is the ratio of x (width) to y (height).
  near | Specifies the distance from the viewer to the near clipping plane (always positive).
  far | Specifies the distance from the viewer to the far clipping plane (always positive).

Template Parameters

  T | Value type used to build the matrix. Currently supported: half (not recommanded), float or double.

See also
  GLM_GTC_matrix_transform

GLM_FUNC_DECL tmat4x4<T, defaultp> glm::perspectiveFov | ( | T | fov,
|  | T | width,
|  | T | height,
|  | T | near,
|  | T | far
| ) |  |

Builds a perspective projection matrix based on a field of view and the default handedness.

Parameters

  fov | Expressed in radians.
  width |
  height |
  near | Specifies the distance from the viewer to the near clipping plane (always positive).
  far | Specifies the distance from the viewer to the far clipping plane (always positive).

Template Parameters

  T | Value type used to build the matrix. Currently supported: half (not recommanded), float or double.

See also
  GLM_GTC_matrix_transform

GLM_FUNC_DECL tmat4x4<T, defaultp> glm::perspectiveFovLH | ( | T | fov,
|  | T | width,
|  | T | height,
|  | T | near,
|  | T | far
| ) |  |

Builds a left handed perspective projection matrix based on a field of view.

Parameters

  fov | Expressed in radians.
  width |
  height |
  near | Specifies the distance from the viewer to the near clipping plane (always positive).
  far | Specifies the distance from the viewer to the far clipping plane (always positive).

Template Parameters

  T | Value type used to build the matrix. Currently supported: half (not recommanded), float or double.

See also
  GLM_GTC_matrix_transform

GLM_FUNC_DECL tmat4x4<T, defaultp> glm::perspectiveFovRH | ( | T | fov,
|  | T | width,
|  | T | height,
|  | T | near,
|  | T | far
| ) |  |

Builds a right handed perspective projection matrix based on a field of view.

Parameters

  fov | Expressed in radians.
  width |
  height |
  near | Specifies the distance from the viewer to the near clipping plane (always positive).
  far | Specifies the distance from the viewer to the far clipping plane (always positive).

Template Parameters

  T | Value type used to build the matrix. Currently supported: half (not recommanded), float or double.

See also
  GLM_GTC_matrix_transform

GLM_FUNC_DECL tmat4x4<T, defaultp> glm::perspectiveLH | ( | T | fovy,
|  | T | aspect,
|  | T | near,
|  | T | far
| ) |  |

Creates a matrix for a left handed, symetric perspective-view frustum.

Parameters

  fovy | Specifies the field of view angle, in degrees, in the y direction. Expressed in radians.
  aspect | Specifies the aspect ratio that determines the field of view in the x direction. The aspect ratio is the ratio of x (width) to y (height).
  near | Specifies the distance from the viewer to the near clipping plane (always positive).
  far | Specifies the distance from the viewer to the far clipping plane (always positive).

Template Parameters

  T | Value type used to build the matrix. Currently supported: half (not recommanded), float or double.

See also
  GLM_GTC_matrix_transform

GLM_FUNC_DECL tmat4x4<T, defaultp> glm::perspectiveRH | ( | T | fovy,
|  | T | aspect,
|  | T | near,
|  | T | far
| ) |  |

Creates a matrix for a right handed, symetric perspective-view frustum.

Parameters

  fovy | Specifies the field of view angle, in degrees, in the y direction. Expressed in radians.
  aspect | Specifies the aspect ratio that determines the field of view in the x direction. The aspect ratio is the ratio of x (width) to y (height).
  near | Specifies the distance from the viewer to the near clipping plane (always positive).
  far | Specifies the distance from the viewer to the far clipping plane (always positive).

Template Parameters

  T | Value type used to build the matrix. Currently supported: half (not recommanded), float or double.

See also
  GLM_GTC_matrix_transform

GLM_FUNC_DECL tmat4x4<T, P> glm::pickMatrix | ( | tvec2< T, P > const & | center,
|  | tvec2< T, P > const & | delta,
|  | tvec4< U, P > const & | viewport
| ) |  |

Define a picking region.

Parameters

  center |
  delta |
  viewport |

Template Parameters

  T | Native type used for the computation. Currently supported: half (not recommanded), float or double.
  U | Currently supported: Floating-point types and integer types.

See also
  GLM_GTC_matrix_transform

GLM_FUNC_DECL tvec3<T, P> glm::project | ( | tvec3< T, P > const & | obj,
|  | tmat4x4< T, P > const & | model,
|  | tmat4x4< T, P > const & | proj,
|  | tvec4< U, P > const & | viewport
| ) |  |

Map the specified object coordinates (obj.x, obj.y, obj.z) into window coordinates.

Parameters

  obj | Specify the object coordinates.
  model | Specifies the current modelview matrix
  proj | Specifies the current projection matrix
  viewport | Specifies the current viewport

Returns
  Return the computed window coordinates.

Template Parameters

  T | Native type used for the computation. Currently supported: half (not recommanded), float or double.
  U | Currently supported: Floating-point types and integer types.

See also
  GLM_GTC_matrix_transform

GLM_FUNC_DECL tmat4x4<T, P> glm::rotate | ( | tmat4x4< T, P > const & | m,
|  | T | angle,
|  | tvec3< T, P > const & | axis
| ) |  |

Builds a rotation 4 * 4 matrix created from an axis vector and an angle.

Parameters

  m | Input matrix multiplied by this rotation matrix.
  angle | Rotation angle expressed in radians.
  axis | Rotation axis, recommended to be normalized.

Template Parameters

  T | Value type used to build the matrix. Supported: half, float or double.

See also
  GLM_GTC_matrix_transform
  - rotate(tmat4x4<T, P> const & m, T angle, T x, T y, T z)
  - rotate(T angle, tvec3<T, P> const & v)

GLM_FUNC_DECL tmat4x4<T, P> glm::scale | ( | tmat4x4< T, P > const & | m,
|  | tvec3< T, P > const & | v
| ) |  |

Builds a scale 4 * 4 matrix created from 3 scalars.

Parameters

  m | Input matrix multiplied by this scale matrix.
  v | Ratio of scaling for each axis.

Template Parameters

  T | Value type used to build the matrix. Currently supported: half (not recommanded), float or double.

See also
  GLM_GTC_matrix_transform
  - scale(tmat4x4<T, P> const & m, T x, T y, T z)
  - scale(tvec3<T, P> const & v)

GLM_FUNC_DECL tmat4x4<T, P> glm::translate | ( | tmat4x4< T, P > const & | m,
|  | tvec3< T, P > const & | v
| ) |  |

Builds a translation 4 * 4 matrix created from a vector of 3 components.

Parameters

  m | Input matrix multiplied by this translation matrix.
  v | Coordinates of a translation vector.

Template Parameters

  T | Value type used to build the matrix. Currently supported: half (not recommanded), float or double. #include <glm/glm.hpp> #include <glm/gtc/matrix_transform.hpp> ... glm::mat4 m = glm::translate(glm::mat4(1.0f), glm::vec3(1.0f)); // m[0][0] == 1.0f, m[0][1] == 0.0f, m[0][2] == 0.0f, m[0][3] == 0.0f // m[1][0] == 0.0f, m[1][1] == 1.0f, m[1][2] == 0.0f, m[1][3] == 0.0f // m[2][0] == 0.0f, m[2][1] == 0.0f, m[2][2] == 1.0f, m[2][3] == 0.0f // m[3][0] == 1.0f, m[3][1] == 1.0f, m[3][2] == 1.0f, m[3][3] == 1.0f

See also
  GLM_GTC_matrix_transform
  - translate(tmat4x4<T, P> const & m, T x, T y, T z)
  - translate(tvec3<T, P> const & v)

GLM_FUNC_DECL tmat4x4<T, defaultp> glm::tweakedInfinitePerspective | ( | T | fovy,
|  | T | aspect,
|  | T | near
| ) |  |

Creates a matrix for a symmetric perspective-view frustum with far plane at infinite for graphics hardware that doesn't support depth clamping.

Parameters

  fovy | Specifies the field of view angle, in degrees, in the y direction. Expressed in radians.
  aspect | Specifies the aspect ratio that determines the field of view in the x direction. The aspect ratio is the ratio of x (width) to y (height).
  near | Specifies the distance from the viewer to the near clipping plane (always positive).

Template Parameters

  T | Value type used to build the matrix. Currently supported: half (not recommanded), float or double.

See also
  GLM_GTC_matrix_transform

GLM_FUNC_DECL tmat4x4<T, defaultp> glm::tweakedInfinitePerspective | ( | T | fovy,
|  | T | aspect,
|  | T | near,
|  | T | ep
| ) |  |

Creates a matrix for a symmetric perspective-view frustum with far plane at infinite for graphics hardware that doesn't support depth clamping.

Parameters

  fovy | Specifies the field of view angle, in degrees, in the y direction. Expressed in radians.
  aspect | Specifies the aspect ratio that determines the field of view in the x direction. The aspect ratio is the ratio of x (width) to y (height).
  near | Specifies the distance from the viewer to the near clipping plane (always positive).
  ep |

Template Parameters

  T | Value type used to build the matrix. Currently supported: half (not recommanded), float or double.

See also
  GLM_GTC_matrix_transform

GLM_FUNC_DECL tvec3<T, P> glm::unProject | ( | tvec3< T, P > const & | win,
|  | tmat4x4< T, P > const & | model,
|  | tmat4x4< T, P > const & | proj,
|  | tvec4< U, P > const & | viewport
| ) |  |

Map the specified window coordinates (win.x, win.y, win.z) into object coordinates.

Parameters

  win | Specify the window coordinates to be mapped.
  model | Specifies the modelview matrix
  proj | Specifies the projection matrix
  viewport | Specifies the viewport

Returns
  Returns the computed object coordinates.

Template Parameters

  T | Native type used for the computation. Currently supported: half (not recommanded), float or double.
  U | Currently supported: Floating-point types and integer types.

See also
  GLM_GTC_matrix_transform